#include <iostream>
#include <vector>

using namespace std;

char to_lower(char c) {
    if ('A' <= c && c <= 'Z') {
        return 'a' + (c - 'A');
    }
    return c;
}

bool is_big(char c) {
    return 'A' <= c && c <= 'Z';
}

bool ok(int i, int j) {
    return (i >= 0) && (i < 8) && (j >= 0) && (j < 8);
}

bool check_dam(int i, int j, char c, vector<string>& a, int n) {
    for (int d = -n; d < 0; ++d) {
        if (ok(i + d, j + d) && a[i + d][j + d] != '_' && to_lower(a[i + d][j + d]) != c &&
            ok(i + d - 1, j + d - 1) && a[i + d - 1][j + d - 1] == '_') {
            return true;
        }
        if (ok(i + d, j - d) && a[i + d][j - d] != '_' && to_lower(a[i + d][j - d]) != c &&
            ok(i + d - 1, j - d + 1) && a[i + d - 1][j - d + 1] == '_') {
            return true;
        }
    }
    for (int d = 1; d < n; ++d) {
        if (ok(i + d, j + d) && a[i + d][j + d] != '_' && to_lower(a[i + d][j + d]) != c &&
            ok(i + d + 1, j + d + 1) && a[i + d + 1][j + d + 1] == '_') {
            return true;
        }
        if (ok(i + d, j - d) && a[i + d][j - d] != '_' && to_lower(a[i + d][j - d]) != c &&
            ok(i + d + 1, j - d - 1) && a[i + d + 1][j - d - 1] == '_') {
            return true;
        }
    }
    return false;
}

bool check_black(int i, int j, vector<string>& a, int n) {
    if (ok(i + 1, j + 1) && to_lower(a[i + 1][j + 1]) == 'w' &&
        ok(i + 2, j + 2) && a[i + 2][j + 2] == '_') {
        return true;
    }
    if (ok(i + 1, j - 1) && to_lower(a[i + 1][j - 1]) == 'w' &&
        ok(i + 2, j - 2) && a[i + 2][j - 2] == '_') {
        return true;
    }
    return false;
}

bool check_white(int i, int j, vector<string>& a, int n) {
    if (ok(i - 1, j + 1) && to_lower(a[i - 1][j + 1]) == 'b' &&
        ok(i - 2, j + 2) && a[i - 2][j + 2] == '_') {
        return true;
    }
    if (ok(i - 1, j - 1) && to_lower(a[i - 1][j - 1]) == 'b' &&
        ok(i - 2, j - 2) && a[i - 2][j - 2] == '_') {
        return true;
    }
    return false;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    char c;
    cin >> c;
    vector<string> a(8);
    string tmp;
    getline(cin, tmp);
    for (int i = 0; i < 8; ++i) {
        getline(cin, a[i]);
    }
    for (int i = 0; i < 8; ++i) {
        for (int j = 0; j < 16; j += 2) {
            a[i][j / 2] = a[i][j];
        }
        a[i].resize(8);
    }
    int n = 8;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (to_lower(a[i][j]) == c) {
                if (is_big(a[i][j])) {
                    if (check_dam(i, j, c, a, n)) {
                        cout << i + 1 << " " << j + 1;
                        return 0;
                    }
                } else {
                    if (c == 'b' && check_black(i, j, a, n)) {
                        cout << i + 1 << " " << j + 1;
                        return 0;
                    }
                    if (c == 'w' && check_white(i, j, a, n)) {
                        cout << i + 1 << " " << j + 1;
                        return 0;
                    }
                }
            }
        }
    }
}
