#include <iostream>
#include <vector>

using namespace std;

bool connect(int cur, int next, vector<vector<vector<int>>>& a) {
    for (int m = 1; m <= 3; ++m) {
        vector<vector<int>> tmp = a[cur];
        bool flag = true;
        for (int i = m; i < 4; ++i) {
            for (int j = 0; j < 4; ++j) {
                if (tmp[i - m][j] == 1 && a[next][i][j] == 1) {
                    flag = false;
                } else {
                    tmp[i - m][j] = max(tmp[i - m][j], a[next][i][j]);
                }
            }
        }
        if (flag) {
            for (int i = 0; i < m; ++i) {
                for (int j = 0; j < 4; ++j) {
                    if (tmp[i][j] == 0) {
                        return false;
                    }
                }
            }
            return true;
        }
    }
    return false;
}

vector<int> ans;

bool is_end(int cur, vector<vector<vector<int>>>& a) {
    for (int i = 0; i < 4; ++i) {
        if (a[cur][0][i] == 0) {
            return false;
        }
    }
    return true;
}

void rec(int cur, vector<int>& p, vector<int>& used, vector<vector<vector<int>>>& a, int n) {
    if (is_end(cur, a)) {
        ans = p;
    }
    for (int next = 0; next < n; ++next) {
        if (used[next] == 1)
            continue;
        if (connect(cur, next, a)) {
            p.push_back(next);
            used[next] = 1;
            rec(next, p, used, a, n);
            p.pop_back();
            used[next] = 0;
        }
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n;
    cin >> n;
    vector<vector<vector<int>>> a(n, vector<vector<int>>(4, vector<int>(4, 0)));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < 4; ++j) {
            for (int k = 0; k < 4; ++k) {
                cin >> a[i][j][k];
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        bool flag = true;
        for (int j = 0; j < 4; ++j) {
            if (a[i][3][j] == 0) {
                flag = false;
            }
        }
        if (flag) {
            vector<int> p;
            p.push_back(i);
            vector<int> used(n, 0);
            used[i] = 1;
            rec(i, p, used, a, n);
        }
    }
    for (int i : ans)
        cout << i + 1 << " ";
}
