﻿#include <iostream>
#include <vector>

struct fabric {
	int building;
	int pr_cur_time, con_cur_time;
	int pr_cycle, pr_amount1, pr_amount2, pr_amount3, pr_amount4;
	int con_cycle, con_amount1, con_amount2, con_amount3, con_amount4;
};

void check(std::vector<fabric>& fabrics, std::vector<int>& resources) {
	for (int i = 0; i < fabrics.size(); ++i) {
		--fabrics[i].building;
		if (fabrics[i].building <	 0) {
			++fabrics[i].con_cur_time;
			++fabrics[i].pr_cur_time;
			if (fabrics[i].pr_cur_time == fabrics[i].pr_cycle) {
				resources[0] += fabrics[i].pr_amount1;
				resources[1] += fabrics[i].pr_amount2;
				resources[2] += fabrics[i].pr_amount3;
				resources[3] += fabrics[i].pr_amount4;
				fabrics[i].pr_cur_time = 0;
			}
			if (fabrics[i].con_cur_time == fabrics[i].con_cycle) {
				resources[0] -= fabrics[i].con_amount1;
				resources[1] -= fabrics[i].con_amount2;
				resources[2] -= fabrics[i].con_amount3;
				resources[3] -= fabrics[i].con_amount4;
				fabrics[i].con_cur_time = 0;
			}
		}
	}
}

void solution() {
	int day = 1;
	std::vector<fabric> fabrics;
	std::vector<int> resourses(4, 40);
	std::vector<std::vector<int>> plan(4, std::vector<int>(5));
	int X, Y;
	std::cin >> X >> Y;
	for (int i = 0; i < 4; ++i) {
		for (int j = 0; j < 5; ++j) {
			std::cin >> plan[i][j];
		}
	}
	while (day != 101 && resourses[0] > 0 && resourses[1] > 0 && resourses[2] > 0 && resourses[3] > 0) {
		if (day % 10 == 0) {
			resourses[0] += X;
			resourses[1] += X;
			resourses[2] += X;
			resourses[3] += X;
		}
		for (int i = 0; i < 4; ++i) {
			for (int j = 0; j < 5; ++j) {
				if (plan[i][j] == day) {
					fabric new_fabric;
					if (i == 0) {
						resourses[0] -= 5;
						resourses[1] -= 5;
						resourses[2] -= 5;
						resourses[3] -= 0;
						new_fabric.building = 6;
						new_fabric.pr_cur_time = 0;
						new_fabric.con_cur_time = 0;
						new_fabric.pr_cycle = 2;
						new_fabric.pr_amount1 = 2;
						new_fabric.pr_amount2 = 0;
						new_fabric.pr_amount3 = 1;
						new_fabric.pr_amount4 = 0;
						new_fabric.con_cycle = 5;
						new_fabric.con_amount1 = 1;
						new_fabric.con_amount2 = 0;
						new_fabric.con_amount3 = 0;
						new_fabric.con_amount4 = 0;
						
					}
					if (i == 1) {
						resourses[0] -= 5;
						resourses[1] -= 0;
						resourses[2] -= 10;
						resourses[3] -= 0;
						new_fabric.building = 4;
						new_fabric.pr_cur_time = 0;
						new_fabric.con_cur_time = 0;
						new_fabric.pr_cycle = 6;
						new_fabric.pr_amount1 = 0;
						new_fabric.pr_amount2 = 0;
						new_fabric.pr_amount3 = 0;
						new_fabric.pr_amount4 = 8;
						new_fabric.con_cycle = 10;
						new_fabric.con_amount1 = 0;
						new_fabric.con_amount2 = 0;
						new_fabric.con_amount3 = 2;
						new_fabric.con_amount4 = 0;
					}
					if (i == 2) {
						resourses[0] -= 10;
						resourses[1] -= 5;
						resourses[2] -= 10;
						resourses[3] -= 0;
						new_fabric.building = 10;
						new_fabric.pr_cur_time = 0;
						new_fabric.con_cur_time = 0;
						new_fabric.pr_cycle = 10;
						new_fabric.pr_amount1 = 0;
						new_fabric.pr_amount2 = 6;
						new_fabric.pr_amount3 = 0;
						new_fabric.pr_amount4 = 0;
						new_fabric.con_cycle = 20;
						new_fabric.con_amount1 = 2;
						new_fabric.con_amount2 = 0;
						new_fabric.con_amount3 = 0;
						new_fabric.con_amount4 = 0;
					}
					if (i == 3) {
						resourses[0] -= 10;
						resourses[1] -= 5;
						resourses[2] -= 8;
						resourses[3] -= 0;
						new_fabric.building = 10;
						new_fabric.pr_cur_time = 0;
						new_fabric.con_cur_time = 0;
						new_fabric.pr_cycle = 7;
						new_fabric.pr_amount1 = 0;
						new_fabric.pr_amount2 = 0;
						new_fabric.pr_amount3 = 7;
						new_fabric.pr_amount4 = 0;
						new_fabric.con_cycle = 12;
						new_fabric.con_amount1 = 1;
						new_fabric.con_amount2 = 1;
						new_fabric.con_amount3 = 0;
						new_fabric.con_amount4 = 0;
					}
					fabrics.push_back(new_fabric);
				}
			}
		}
		if (resourses[0] <= 0 || resourses[1] <= 0 || resourses[2] <= 0 || resourses[3] <= 0) {
			break;
		}
		check(fabrics, resourses);
		if (resourses[0] <= 0 || resourses[1] <= 0 || resourses[2] <= 0 || resourses[3] <= 0) {
			break;
		}
		resourses[0] -= Y;
		resourses[1] -= Y;
		resourses[2] -= Y;
		resourses[3] -= Y;
		++day;
	}
	std::cout << "\n";
	std::cout << day - 1 << "\n" << resourses[0] << "\n" << resourses[1] << "\n" << resourses[2] << "\n" << resourses[3];
}

int main() {
	std::ios::sync_with_stdio(0);
	std::cin.tie(0);
	std::cout.tie(0);
	solution();
	return 0;
}