#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;

const int inf = 1e9 + 7;

struct event {
	ll day;
	ll z, m, p, eat;
	ll typ; // 1 - insert, 2 - erase
	event() {}
	event(ll a, ll b, ll c, ll d, ll e, ll f) : day(a), z(b), m(c), p(d), eat(e), typ(f) {}
};

bool cmp(event& a, event& b) {
	if (a.day == b.day) return a.typ < b.typ;
	else return a.day < b.day;
}

ll za = 40, micro = 40, plas = 40, food = 40;

void inc(event& x) {
	if (x.typ == 2) {
		za -= x.z;
		micro -= x.m;
		plas -= x.p;
		food -= x.eat;
	}
	else {
		za += x.z;
		micro += x.m;
		plas += x.p;
		food += x.eat;
	}
}

bool is() {
	if (za <= 0 || micro <= 0 || plas <= 0 || food <= 0) return false;
	else return true;
}

vector<event> eva;

signed main() {
	cin.tie(0)->sync_with_stdio(0);
	ll x, y;
	cin >> x >> y;
	for (int i = 1; i <= 4; ++i) {
		for (int j = 1; j <= 5; ++j) {
			int dx;
			cin >> dx;
			if (!dx) continue;
			if (i == 1) {
				eva.emplace_back(dx, 5, 5, 5, 0, 2);
				for (int it = dx + 7; it < 101; it += 2) {
					eva.emplace_back(it, 2, 0, 1, 0, 1);
				}
				for (int it = dx + 10; it < 101; it += 5) {
					eva.emplace_back(it, 1, 0, 0, 0, 2);
				}
			}
			else if (i == 2) {
				eva.emplace_back(dx, 5, 0, 10, 0, 2);
				for (int it = dx + 9; it < 101; it += 6) {
					eva.emplace_back(it, 0, 0, 0, 8, 1);
				}
				for (int it = dx + 13; it < 101; it += 10) {
					eva.emplace_back(it, 0, 0, 2, 0, 2);
				}
			}
			else if (i == 3) {
				eva.emplace_back(dx, 10, 5, 10, 0, 2);
				for (int it = dx + 19; it < 101; it += 10) {
					eva.emplace_back(it, 0, 6, 0, 0, 1);
				}
				for (int it = dx + 29; it < 101; it += 20) {
					eva.emplace_back(it, 2, 0, 0, 0, 2);
				}
			}
			else if (i == 4) {
				eva.emplace_back(dx, 10, 5, 8, 0, 2);
				for (int it = dx + 14; it < 101; it += 7) {
					eva.emplace_back(it, 0, 0, 7, 0, 1);
				}
				for (int it = dx + 19; it < 101; it += 12) {
					eva.emplace_back(it, 1, 1, 0, 0, 2);
				}
			}
		}
	}
	for (int i = 1; i <= 100; ++i) {
		eva.emplace_back(i, y, y, y, y, 2);
	}
	for (int i = 10; i <= 100; i += 10) {
		eva.emplace_back(i, x, x, x, x, 1);
	}
	sort(eva.begin(), eva.end(), cmp);
	int ddd = -1;
	for (int i = 0; i < eva.size(); ++i) {
		if (ddd != -1 && eva[i].day != ddd) break;
		inc(eva[i]);
		if (!is()) ddd = eva[i].day;
	}
	cout << (ddd == -1 ? 100 : ddd) << "\n" << za << "\n" << micro << "\n" << plas << "\n" << food << "\n";
	return 0;
}