#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <iomanip>
#include <cmath>

using namespace std;

#define INFI 2e9
#define INFL 2e18
typedef long long ll;
typedef long double ld;
typedef pair<int, int> point;

point dirs[8]{
    {-1, -1},
    {-1, 0},
    {-1, 1},
    {0, -1},
    {0, 1},
    {1, -1},
    {1, 0},
    {1, 1}
};

vector<vector<int>> matrix;
vector<vector<vector<bool>>> visited;

int change_dir(int x, int y, int dir) {
    dir++;
    if (x == 0) {
        if (y == 0 && dir == 1) {
            return 8;
        }
        if (y == matrix[x].size() - 1 && dir == 3) {
            return 6;
        }
        switch (dir) {
        case 1:
            return 6;
        case 2:
            return 7;
        case 3:
            return 8;
        }
    }
    if (x == matrix.size() - 1) {
        if (y == 0 && dir == 6) {
            return 3;
        }
        if (y == matrix[x].size() - 1 && dir == 8) {
            return 1;
        }
        switch (dir) {
        case 6:
            return 1;
        case 7:
            return 2;
        case 8:
            return 3;
        }
    }
    if (y == 0) {
        switch (dir) {
        case 1:
            return 3;
        case 4:
            return 5;
        case 6:
            return 8;
        }
    }
    if (y == matrix[x].size() - 1) {
        switch (dir) {
            case 3:
                return 1;
            case 5:
                return 4;
            case 8:
                return 6;
        }
    }
    return -1;
}

bool is_illegal(int x, int y) {
    return (x < 0 || x >= matrix.size() || y < 0 || y >= matrix[0].size());
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n, m;
    cin >> n >> m;
    matrix.resize(n, vector<int>(m));
    visited.resize(n, vector<vector<bool>>(m, vector<bool> (8, false)));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> matrix[i][j];
        }
    }
    int sx, sy;
    cin >> sx >> sy;
    sx--;
    sy--;
    int step, dir;
    cin >> dir >> step;
    dir--;
    long long count = 0;
    int i = 0;

    while (!is_illegal(sx, sy) && !visited[sx][sy][dir]) {
        visited[sx][sy][dir] = true;
        //cout << sx << ' ' << sy << ' ' << matrix[sx][sy] << endl;
        if (i % step == 0) {
            count += matrix[sx][sy];
            matrix[sx][sy] = 0;
        }
        int nx = sx + dirs[dir].first, ny = sy + dirs[dir].second;
        if (is_illegal(nx, ny)) {
            dir = change_dir(sx, sy, dir) - 1;
            nx = sx + dirs[dir].first, ny = sy + dirs[dir].second;
        }
        //cout << sx << ' ' << sy << ':' << dir << endl;
        sx = nx;
        sy = ny;
        i++;
    }
    cout << count;
    return 0;
}