
class Point:
    def __init__(self, x, y):
        self.x = x
        self.y = y


class Wall:
    def __init__(self, a, b, intensity, rect):
        self.a = a
        self.b = b
        self.intensity = intensity / 100
        self.rect = rect


angle, intensity_start = map(int, input().split())
n = int(input())

hor_walls = []
vert_walls = []

for _ in range(n):
    x1, y1, x2, y2, intensity = map(int, input().split())
    x3, y3 = min(x1, x2), min(y1, y2)
    x4, y4 = max(x1, x2), max(y1, y2)

    p1 = Point(x1, y1)
    p2 = Point(x2, y2)
    p3 = Point(x3, y3)
    p4 = Point(x4, y4)

    vert_walls.append(Wall(p3, p1, intensity, [p1, p2]))
    vert_walls.append(Wall(p2, p4, intensity, [p1, p2]))
    hor_walls.append(Wall(p1, p4, intensity, [p1, p2]))
    hor_walls.append(Wall(p3, p2, intensity, [p1, p2]))

x_target, y_target = map(int, input().split())

spx, spy = 0, 0
if angle in [0, 45, 315]:
    spx = 1
if angle in [135, 180, 225]:
    spx = - 1
if angle in [45, 90, 135]:
    spy = 1
if angle in [225, 270, 315]:
    spy = -1


x, y = 0, 0
intensity = intensity_start
last_rect = []

while x != x_target or y != y_target:
    x += spx
    y += spy

    for wall in hor_walls:
        if wall.a.x <= x <= wall.b.x and wall.a.y == wall.b.y == y:
            spy = -spy
            if spx != 0:
                intensity -= intensity * wall.intensity
            last_rect = wall.rect
            break
    else:
        for wall in vert_walls:
            if wall.a.y <= y <= wall.b.y and wall.a.x == wall.b.x == x:
                spx = -spx
                if spy != 0:
                    intensity -= intensity * wall.intensity
                last_rect = wall.rect
                break

    if intensity < intensity_start * 0.1:
        print(last_rect[0].x, last_rect[0].y, last_rect[1].x, last_rect[1].y, int(intensity))
        exit()

print(int(intensity))
