class Plate:
    def __init__(self, x1, y1, x2, y2, sub):
        self.x1 = x1
        self.y1 = y1
        self.x2 = x2
        self.y2 = y2
        self.leave = 1 - sub/100

        self.is_vert = x1 == x2
        self.boundxl = min(x1, x2)
        self.boundxr = max(x1, x2)
        self.boundyt = max(y1, y2)
        self.boundyb = min(y1, y2)
            
        if not self.is_vert:
            self.k = (y1-y2) / (x1-x2)
            self.b = y1 - self.k * x1
            assert self.b == (y2 - self.k * x2)

            

    def intersect(self, x, y):
        if self.is_vert:
            return x == self.x1 and y in range(self.boundyb, self.boundyt + 1)
        if y not in range(self.boundyb, self.boundyt + 1):
            return False
        if x not in range(self.boundxl, self.boundxr + 1):
            return False
        if y == self.k * x + self.b:
            return True
        return False

    def angle(self):
        if self.is_vert:
            return 90
        if self.k == 1:
            return 45
        elif self.k == 0:
            return 0
        if self.k == -1:
            return 135

    def reflect(self, v):
        alpha2 = angles_to_vecs[v]
        return vecs[int(2*self.angle()-alpha2)%360]

    def __str__(self):
        return f"{self.x1} {self.y1} {self.x2} {self.y2}"
    
vecs = {
    0: (1, 0),
    45: (1, 1),
    90: (0, 1),
    135: (-1, 1),
    180: (-1, 0),
    225: (-1, -1),
    270: (0, -1),
    315: (1, -1)
    }

angles_to_vecs = {val: key for key, val in vecs.items()}
angle, intens = map(int, input().split())
intens_min = intens * 0.1


v = vecs[angle]
plates = []
for _ in range(int(input())):
    plates.append(Plate(*[int(x) for x in input().split()]))

xfinal, yfinal = map(int, input().split())
x, y = 0, 0
while True:

    if x == xfinal and y == yfinal:
        print(int(intens))
        break

    x += v[0]
    y += v[1]
    break_while = False
    for plate in plates:
        if plate.intersect(x, y):
            v = plate.reflect(v)
            #if plate.intersect(x, y-v[1]):
            #    v = (-v[0], v[1])
            #elif plate.intersect(x-v[0], y):
            #    v = (v[0], -v[1])
            #else:
            #    v = (-v[0], -v[1])
            intens = intens * plate.leave
            if intens <= intens_min:
                break_while = True
                print(plate, int(intens))
            break
    if break_while:
        break
    
    
               
