X = int(input())
Y = int(input())

buildings: list[list[int]] = []
build_matrix_l = [4, 5]
# Factories:
# parts         0
# microscemes   1
# plastic       2
# food          3
events: list[dict[int, int]] = []


def set_factory_event(factory_i, day, event_list):
    events = event_list
    events[day][int(f"1{factory_i}")] += 1
    if factory_i == 0:
        # parts
        events[day][0] -= 5
        events[day][1] -= 5
        events[day][2] -= 5

        # receiving income
        cur_day = day + 6 + 2
        while cur_day <= 100:
            events[cur_day][0] += 2
            events[cur_day][2] += 1
            cur_day += 2

        # paying
        cur_day = day + 6 + 5
        while cur_day <= 100:
            events[cur_day][0] -= 1
            cur_day += 5
        for i in range(6):
            if day + i <= 100:
                events[day + i][int(f"2{factory_i}")] += 1
    elif factory_i == 1:
        # micro
        events[day][0] -= 10
        events[day][1] -= 5
        events[day][2] -= 10

        # receiving income
        cur_day = day + 10 + 10
        while cur_day <= 100:
            events[cur_day][1] += 6
            cur_day += 10

        # paying
        cur_day = day + 10 + 20
        while cur_day <= 100:
            events[cur_day][0] -= 2
            cur_day += 20
        for i in range(10):
            if day + i <= 100:
                events[day + i][int(f"2{factory_i}")] += 1
    elif factory_i == 2:
        # plastic
        events[day][0] -= 10
        events[day][1] -= 5
        events[day][2] -= 8

        # receiving income
        cur_day = day + 8 + 7
        while cur_day <= 100:
            events[cur_day][2] += 7
            cur_day += 7

        # paying
        cur_day = day + 8 + 12
        while cur_day <= 100:
            events[cur_day][0] -= 1
            events[cur_day][1] -= 1
            cur_day += 12
        for i in range(8):
            if day + i <= 100:
                events[day + i][int(f"2{factory_i}")] += 1
    elif factory_i == 3:
        # food
        events[day][0] -= 5
        events[day][2] -= 10

        # receiving income
        cur_day = day + 4 + 6
        while cur_day <= 100:
            events[cur_day][3] += 8
            cur_day += 6

        # paying
        cur_day = day + 4 + 10
        while cur_day <= 100:
            events[cur_day][2] -= 2
            cur_day += 10
        for i in range(4):
            if day + i <= 100:
                events[day + i][int(f"2{factory_i}")] += 1
    return events


def undo_factory_event(factory_i, day, event_list):
    events = event_list
    events[day][int(f"1{factory_i}")] -= 1
    if factory_i == 0:
        # parts
        events[day][0] += 5
        events[day][1] += 5
        events[day][2] += 5

        # receiving income
        cur_day = day + 6 + 2
        while cur_day <= 100:
            events[cur_day][0] -= 2
            events[cur_day][2] -= 1
            cur_day += 2

        # paying
        cur_day = day + 6 + 5
        while cur_day <= 100:
            events[cur_day][0] += 1
            cur_day += 5
        for i in range(6):
            if day + i <= 100:
                events[day + i][int(f"2{factory_i}")] -= 1
    elif factory_i == 1:
        # micro
        events[day][0] += 10
        events[day][1] += 5
        events[day][2] += 10

        # receiving income
        cur_day = day + 10 + 10
        while cur_day <= 100:
            events[cur_day][1] -= 6
            cur_day += 10

        # paying
        cur_day = day + 10 + 20
        while cur_day <= 100:
            events[cur_day][0] += 2
            cur_day += 20
        for i in range(10):
            if day + i <= 100:
                events[day + i][int(f"2{factory_i}")] -= 1
    elif factory_i == 2:
        # plastic
        events[day][0] += 10
        events[day][1] += 5
        events[day][2] += 8

        # receiving income
        cur_day = day + 8 + 7
        while cur_day <= 100:
            events[cur_day][2] -= 7
            cur_day += 7

        # paying
        cur_day = day + 8 + 12
        while cur_day <= 100:
            events[cur_day][0] += 1
            events[cur_day][1] += 1
            cur_day += 12
        for i in range(8):
            if day + i <= 100:
                events[day + i][int(f"2{factory_i}")] -= 1
    elif factory_i == 3:
        # food
        events[day][0] += 5
        events[day][2] += 10

        # receiving income
        cur_day = day + 4 + 6
        while cur_day <= 100:
            events[cur_day][3] -= 8
            cur_day += 6

        # paying
        cur_day = day + 4 + 10
        while cur_day <= 100:
            events[cur_day][2] += 2
            cur_day += 10
        for i in range(4):
            if day + i <= 100:
                events[day + i][int(f"2{factory_i}")] -= 1
    return events


for _ in range(101):
    events.append({
        0: 0,
        1: 0,
        2: 0,
        3: 0,
        10: 0, # Start of building factory
        11: 0,
        12: 0,
        13: 0,
        20: 0, # Process of building factory
        21: 0,
        22: 0,
        23: 0,
    })

for factory_i in range(build_matrix_l[0]):
    buildings.append([])
    for _ in range(build_matrix_l[1]):
        day = int(input())
        if day != 0:
            buildings[factory_i].append(day)
            events = set_factory_event(factory_i, day, events)
            


current_state: list[int] = [X] * 4
for day in range(1, 101):
    for _ in range(events[day][20] - 1):
        events = undo_factory_event(0, day, events)
    for _ in range(events[day][21] - 1):
        events = undo_factory_event(1, day, events)
    for _ in range(events[day][22] - 1):
        events = undo_factory_event(2, day, events)
    for _ in range(events[day][23] - 1):
        events = undo_factory_event(3, day, events)
    possible_state = [current_state[resourse_i] + events[day][resourse_i] - Y for resourse_i in range(len(current_state))]
    if possible_state[0] < 0 and events[day][10] > 0:
        events = undo_factory_event(0, day, events)
    if possible_state[1] < 0 and events[day][11] > 0:
        events = undo_factory_event(1, day, events)
    if possible_state[2] < 0 and events[day][12] > 0:
        events = undo_factory_event(2, day, events)
    if possible_state[3] < 0 and events[day][13] > 0:
        events = undo_factory_event(3, day, events)
    current_state = [current_state[resourse_i] + events[day][resourse_i] - Y for resourse_i in range(len(current_state))]
    if min(current_state) <= 0:
        break

print("\n".join([str(day), *[str(x) for x in current_state]]))

