def add(res, gain_data):
    new = []
    for i in range(min(len(res), len(gain_data))):
        new.append(res[i] + gain_data[i])
    return new


def sub(res, use_data):
    new = []
    for i in range(min(len(res), len(use_data))):
        new.append(res[i] - use_data[i])
    return new


class Factory:
    def __init__(self, build_date, build_time, build_res, gain_period, gain_res, use_period, use_res):
        self.build_date = build_date
        self.build_time = build_time
        self.build_res = build_res
        self.gain_period = gain_period
        self.gain_res = gain_res
        self.use_period = use_period
        self.use_res = use_res

        self.first_gain_date = self.build_date + build_time + self.gain_period - 1
        self.first_use_date = self.build_date + build_time + self.use_period - 1

    def res_data(self, t):
        res = [0, 0, 0, 0]

        if t - self.first_gain_date >= 0 and (t - self.first_gain_date) % self.gain_period == 0:
            res = add(res, self.gain_res)
        if t - self.first_use_date >= 0 and (t - self.first_use_date) % self.use_period == 0:
            res = sub(res, self.use_res)

        return res


factories_data = {
    0: (5, [8, 3, 10, 0], 2, [2, 0, 5, 0], 5, [3, 0, 0, 0]),
    1: (5, [5, 0, 8, 0], 5, [0, 0, 0, 7], 10, [0, 0, 2, 0]),
    2: (10, [10, 6, 10, 0], 10, [0, 6, 0, 0], 18, [2, 0, 0, 0]),
    3: (8, [8, 4, 8, 0], 8, [0, 0, 8, 0], 12, [1, 1, 0, 0]),
}


x, y = int(input()), int(input())

# ТИ, ЭП, Б, Е
gain_data = [x, x, x, x]
use_data = [y, y, y, y]

building_plan = [[0 for __ in range(5)] for _ in range(4)]

for factory_id in range(4):
    for index in range(5):
        building_plan[factory_id][index] = int(input())

for factory_id in range(4):
    for index in range(4):
        if building_plan[factory_id][index + 1] - max([0] + building_plan[factory_id][:index]) < factories_data[factory_id][0]:
            building_plan[factory_id][index + 1] = 0

resources = [30, 30, 30, 30]
factories = []

for t in range(1, 101):

    if t % 10 == 0:
        resources = add(resources, gain_data)

    resources = sub(resources, use_data)

    for factory_id in range(4):
        for index in range(5):
            if building_plan[factory_id][index] == t:
                if all(map(lambda x: x > 0, sub(resources, factories_data[factory_id][1]))) and factories_data:
                    factories.append(Factory(t, *factories_data[factory_id]))
                    resources = sub(resources, factories_data[factory_id][1])

    for factory in factories:
        resources = add(resources, factory.res_data(t))

    if any(map(lambda x: x <= 0, resources)) or t == 100:
        print(t)
        break

print(*resources, sep="\n")