data = {
    0: [1, 0],
    45: [1, 1],
    90: [0, 1],
    135: [-1, 1],
    180: [-1, 0],
    225: [-1, -1],
    270: [0, -1],
    315: [1, -1]
}


def check_collision(ray_pos, ray_dir, p1, p2):
    if (ray_pos[0] - p1[0]) * (ray_pos[0] - p2[0]) > 0 or (ray_pos[1] - p1[1]) * (ray_pos[1] - p2[1]) > 0 or\
            (ray_pos[0] - p1[0]) * (p2[1] - ray_pos[1]) + (ray_pos[1] - p1[1]) * (ray_pos[0] - p2[0]) != 0:
        return False, None
    else:
        dot_p = ray_dir[0] * (ray_pos[0] - p1[0]) + ray_dir[1] * (ray_pos[1] - p1[1])
        if dot_p == 0:
            return True, [-ray_dir[0], -ray_dir[1]]
        else:
            d1 = [-ray_dir[1], ray_dir[0]]
            d2 = [ray_dir[1], -ray_dir[0]]

            if d1[0] * (ray_pos[0] - p1[0]) + d1[1] * (ray_pos[1] - p1[1]) == dot_p:
                return True, d1
            else:
                return True, d2


ray_dir, init_intensity = map(int, input().split())
ray_dir = data[ray_dir]
ray_pos = [0, 0]
intensity = init_intensity

plates = []

for _ in range(int(input())):
    x1, y1, x2, y2, absorb = map(int, input().split())
    plates.append(((x1, y1), (x2, y2), absorb))

end_pos = list(map(int, input().split()))
last_plate = None

while ray_pos != end_pos and intensity >= init_intensity * 0.1:
    ray_pos[0] += ray_dir[0]
    ray_pos[1] += ray_dir[1]

    for plate in plates:
        is_collision, new_dir = check_collision(ray_pos, ray_dir, plate[0], plate[1])
        if is_collision:
            ray_dir = new_dir
            intensity *= 1 - plate[2] / 100
            last_plate = plate
            break

if ray_pos == end_pos:
    print(int(intensity))
else:
    print(*last_plate[0], *last_plate[1], int(intensity))
