from dataclasses import dataclass


@dataclass
class Resurses:
    tokar: int = 30
    electronic_plats: int = 30
    beton: int = 30
    food: int = 30

    def add_all(self, value):
        self.tokar += value
        self.electronic_plats += value
        self.beton += value
        self.food += value

    def remove_all(self, value):
        self.tokar -= value
        self.electronic_plats -= value
        self.beton -= value
        self.food -= value

    @property
    def is_one_emptied(self):
        return (self.tokar <= 0) or (self.electronic_plats <= 0) or (self.beton <= 0) or (self.food <= 0)


@dataclass
class Building:
    id: int
    build_to_month: int
    get_in_next_month: int
    remove_in_next_month: int


X, Y = int(input()), int(input())
data = [[int(input()) for _ in range(5)] for _ in range(4)]
# X, Y = 8, 1
# data = [[1, 20, 70, 0, 0], [50, 0, 0, 0, 0], [90, 0, 0, 0, 0], [60, 70, 0, 0, 0]]
# X, Y = 14, 12
# data = [[84, 0, 0, 0, 0], [15, 0, 0, 0, 0], [89, 0, 0, 0, 0], [19, 48, 87, 0, 0]]


resurses = Resurses()
need_to_build = {
    i + 1: sorted(list(filter(lambda t: t > 0, data[i])))
    for i in range(4)
}
buildings = []
for month in range(1, 101):
    if month % 10 == 0:
        resurses.add_all(X)

    for build_id, months in need_to_build.items():
        if month in months:
            if build_id == 1:
                resurses.tokar -= 8
                resurses.electronic_plats -= 3
                resurses.beton -= 10
                buildings.append(Building(id=1,
                                          build_to_month=month + 5 - 1,
                                          get_in_next_month=month + 5 - 1 + 2,
                                          remove_in_next_month=month + 5 - 1 + 5))
            if build_id == 2:
                resurses.beton -= 8
                resurses.tokar -= 5
                buildings.append(Building(id=2,
                                          build_to_month=month + 5 - 1,
                                          get_in_next_month=month + 5 - 1 + 5,
                                          remove_in_next_month=month + 5 - 1 + 10))
            if build_id == 3:
                resurses.electronic_plats -= 6
                resurses.tokar -= 10
                resurses.beton -= 10
                buildings.append(Building(id=3,
                                          build_to_month=month + 10 - 1,
                                          get_in_next_month=month + 10 - 1 + 10,
                                          remove_in_next_month=month + 10 - 1 + 18))
            if build_id == 4:
                resurses.electronic_plats -= 4
                resurses.tokar -= 8
                resurses.beton -= 8
                buildings.append(Building(id=4,
                                          build_to_month=month + 8 - 1,
                                          get_in_next_month=month + 8 - 1 + 8,
                                          remove_in_next_month=month + 8 - 1 + 12))

    for building in buildings:
        if building.get_in_next_month == month:
            if building.id == 1:
                resurses.beton += 5
                resurses.tokar += 2
                building.get_in_next_month += 2
            elif building.id == 2:
                resurses.food += 7
                building.get_in_next_month += 5
            elif building.id == 3:
                resurses.electronic_plats += 6
                building.get_in_next_month += 10
            elif building.id == 4:
                resurses.beton += 8
                building.get_in_next_month += 8

        if building.remove_in_next_month == month:
            if building.id == 1:
                resurses.tokar -= 3
                building.remove_in_next_month += 5
            elif building.id == 2:
                resurses.beton -= 2
                building.remove_in_next_month += 10
            elif building.id == 3:
                resurses.tokar -= 2
                building.remove_in_next_month += 18
            elif building.id == 4:
                resurses.tokar -= 1
                resurses.electronic_plats -= 1
                building.remove_in_next_month += 12
        if resurses.is_one_emptied:
            break
    if resurses.is_one_emptied:
        break

    resurses.remove_all(Y)
    if resurses.is_one_emptied:
        break

print(month)
print(resurses.tokar)
print(resurses.electronic_plats)
print(resurses.beton)
print(resurses.food)
