#include <iostream>
#include <vector>
#include <map>

using namespace std;


struct vec {
    int x, y;
    vec(int x1, int x2, int y1, int y2) : x(x2 - x1), y(y2 - y1) {}
    vec(int x, int y) : x(x), y(y) {}

    const int operator*(const vec other) const {
        return x * other.x + y * other.y;
    }
};

struct line {
    int x1, y1, x2, y2, p;

    vec vector() {
        return vec(x1, x2, y1, y2);
    }
};


int main() {
    int ang; double pow; cin >> ang >> pow;
    double starting_pow = pow;
    int n; cin >> n;
    vector<line> lines(n);
    for (auto &l: lines) {
        cin >> l.x1 >> l.y1 >> l.x2 >> l.y2 >> l.p;
        if (l.y1 < l.y2 || (l.y1 == l.y2 && l.x1 > l.x2)) {
            swap(l.x1, l.x2);
            swap(l.y1, l.y2);
        }
    }
    int dest_x, dest_y; cin >> dest_x >> dest_y;

    map<int, pair<int, int>> dirs = {
        {0, {1, 0}},
        {45, {1, 1}},
        {90, {0, 1}},
        {135, {-1, 1}},
        {180, {-1, 0}},
        {225, {-1, -1}},
        {270, {0, -1}},
        {315, {1, -1}}
    };

    int dx = dirs[ang].first, dy = dirs[ang].second;
    cout << dx << " " << dy << '\n';

    int x = 0, y = 0;
    while (((pow > 0.1 * starting_pow)) && ((dest_x - x) * (dest_x - x) + (dest_y - y) * (dest_y - y)) > 0.25) {
        for (int i = 0; i < n; i++) {
            // find intersection
            int d1 = (lines[i].x1 - x) * (lines[i].x1 - x) + (lines[i].y1 - y) * (lines[i].y1 - y);
            int d2 = (lines[i].x2 - x) * (lines[i].x2 - x) + (lines[i].y2 - y) * (lines[i].y2 - y); 
            int line_d = (lines[i].x1 - lines[i].x2) * (lines[i].x1 - lines[i].x2) + (lines[i].y1 - lines[i].y2) * (lines[i].y1 - lines[i].y2);
            int a = lines[i].x2 - lines[i].x1;
            int b = lines[i].y1 - lines[i].y2;
            int c = lines[i].x1 * lines[i].y2 - lines[i].y1 * lines[i].x2;
            if ((a * x + b * y + c == 0) && (d1 + d2 == line_d)) {
                pow = pow * lines[i].p / 100;
                int sc = vec(dx, dy) * lines[i].vector();
                if (sc == 0) {
                    dx = -dx;
                    dy = -dy;
                } else if (sc > 0) {
                    int temp1 = dx, temp2 = dy;
                    dx = -temp2;
                    dy = temp1;
                } else {
                    int temp1 = dx, temp2 = dy;
                    dx = temp2;
                    dy = -temp1;
                }
            }
        }
        x += dx;
        y += dy;
    }

    if (pow < 0.1 * starting_pow) {
        for (int i = 0; i < n; i++) {
            // find intersection
            int d1 = (lines[i].x1 - x) * (lines[i].x1 - x) + (lines[i].y1 - y) * (lines[i].y1 - y);
            int d2 = (lines[i].x2 - x) * (lines[i].x2 - x) + (lines[i].y2 - y) * (lines[i].y2 - y); 
            int line_d = (lines[i].x1 - lines[i].x2) * (lines[i].x1 - lines[i].x2) + (lines[i].y1 - lines[i].y2) * (lines[i].y1 - lines[i].y2);
            int a = lines[i].x2 - lines[i].x1;
            int b = lines[i].y1 - lines[i].y2;
            int c = lines[i].x1 * lines[i].y2 - lines[i].y1 * lines[i].x2;
            if ((a * x + b * y + c == 0) && (d1 + d2 == line_d)) {
                cout << lines[i].x1 << " " << lines[i].x2 << " " << lines[i].y1 << " " << lines[i].y2 << " ";
                break;
            }
        }
    }
    cout << (int)pow << "\n";
}