#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>

using namespace std;

typedef vector<vector<int>> block;

int main() {
    int n; cin >> n;
    vector<block> a(n, block(4, vector<int>(4)));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < 4; j++) {
            for (int k = 0; k < 4; k++) {
                cin >> a[i][j][k];
            }
        }
    }

    vector<vector<int>> gr(2 * n);
    for (int i = 0; i < n; i++) {
        // normal
        for (int j = 0; j < n; j++) {
            if (i == j) continue;
            // normal
            vector<int> res(4);
            bool flag = true;
            for (int k = 0; k < 4; k++) {
                res[k] = a[i][0][k] ^ a[j].back()[k];
                if (res[k] == 0) flag = false;
            }
            if (flag) gr[i].push_back(j);
            // reverse
            res.assign(4, 0);
            flag = true;
            for (int k = 0; k < 4; k++) {
                res[k] = a[i][0][k] ^ a[j][0][3 - k];
                if (res[k] == 0) flag = false;
            }
            if (flag) gr[i].push_back(j + n);
        }
        // reverse
        for (int j = 0; j < n; j++) {
            if (i == j) continue;
            // normal
            vector<int> res(4);
            bool flag = true;
            for (int k = 0; k < 4; k++) {
                res[k] = a[i].back()[3 - k] ^ a[j].back()[k];
                if (res[k] == 0) flag = false;
            }
            if (flag) gr[i + n].push_back(j);
            // reverse
            res.assign(4, 0);
            flag = true;
            for (int k = 0; k < 4; k++) {
                res[k] = a[i].back()[3 - k] ^ a[j][0][3 - k];
                if (res[k] == 0) flag = false;
            }
            if (flag) gr[i + n].push_back(j + n);
        }
    }

    int starting = -1;
    for (int i = 0; i < n; i++) {
        if (a[i][0] == vector<int>{1, 1, 1, 1}) {
            starting = i + n;
            break;
        } else if (a[i].back() == vector<int>{1, 1, 1, 1}) {
            starting = i;
            break;
        }
    }

    int ending = -1;
    for (int i = 0; i < n; i++) {
        if (i == (starting % n)) continue;
        if (a[i][0] == vector<int>{1, 1, 1, 1}) {
            ending = i;
            break;
        } else if (a[i].back() == vector<int>{1, 1, 1, 1}) {
            ending = i + n;
            break;
        }
    }

    //cout << starting << " " << ending << "\n";

    /*for (int i = 0; i < 2 * n; i++) {
        cout << i << ": ";
        for (auto &e: gr[i]) cout << e << " ";
        cout << "\n";
    }*/

    queue<int> q;
    vector<bool> used(n);
    q.push(starting);
    vector<int> p(2 * n);
    while (!q.empty()) {
        auto curr = q.front();
        q.pop();
        if (used[curr % n]) continue;
        used[curr % n] = true;

        if (curr == ending) break;
        for (auto &e: gr[curr]) {
            q.push(e);
            p[e] = curr;
        }
    }

    
    vector<int> ans;
    ans.push_back(ending);
    while (ans.back() != starting) {
        ans.push_back(p[ans.back()]);
        //cout << ans.back() << "\n";
    }
    reverse(ans.begin(), ans.end());
    for (auto &e: ans) cout << (e % n) + 1 << " ";
    cout << "\n";
}