#include <iostream>
#include <vector>
#include <cmath>

#define int long long

using namespace std;

double eps = 0.01;

struct p {
    double x1;
    double y1;
    double x2;
    double y2;
    double power;
    int state;

    p() : x1(0), y1(0), x2(0), y2(0), power(0), state(0) {}
    p(double x1, double y1, double x2, double y2, double power, int state) : x1(x1), y1(y1), x2(x2), y2(y2), power(power), state(state) {}
};

bool dist(double x1, double y1, double x2, double y2, double maxdist) {
    return (x2 - x1) * (x2 - x1) + (y2 - y1) * (y2 - y1) < maxdist * maxdist;
}

bool isOnLine(double x, double y, double x1, double y1, double x2, double y2) {
    bool f1 = ((x - x1) * (y2 - y1)) - ((x2 - x1) * (y - y1)) < eps;
    bool f2 = ((x - x2) * (y1 - y2)) - ((x1 - x2) * (y - y2)) < eps;
    return f1 & f2;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int angle;
    double power;

    cin >> angle >> power;

    double curPower = power;

    int n;
    cin >> n;

    vector<p> a(n);

    for (auto& i : a) {
        cin >> i.x1 >> i.y1 >> i.x2 >> i.y2 >> i.power;
        if (i.y1 == i.y2) i.state = 1;
        else if (i.x1 == i.x2) i.state = 3;
        else if ((i.x2 - i.x1 > 0) == (i.y2 - i.y1 > 0)) i.state = 2;
        else i.state = 4;
    }

    double xres, yres;
    cin >> xres >> yres;

    double x = 0.0, y = 0.0;

    double step = 0.1;

    while (true) {
        if (dist(x, y, xres, yres, 0.5)) {
            cout << (int) (curPower);
            exit(0);
        }
        for (int i = 0; i < n; ++i) {
            if (isOnLine(x, y, a[i].x1, a[i].y1, a[i].x2, a[i].y2)) {
                if (angle == 0) {
                    if (a[i].state == 1) continue;
                    else if (a[i].state == 2) angle = 90;
                    else if (a[i].state == 3) angle = 180;
                    else if (a[i].state == 4) angle = 270;
                } else if (angle == 45) {
                    if (a[i].state == 1) angle = 315;
                    else if (a[i].state == 2) continue;
                    else if (a[i].state == 3) angle = 135;
                    else if (a[i].state == 4) angle = 225;
                } else if (angle == 90) {
                    if (a[i].state == 1) angle = 270;
                    else if (a[i].state == 2) angle = 0;
                    else if (a[i].state == 3) continue;
                    else if (a[i].state == 4) angle = 180;
                } else if (angle == 135) {
                    if (a[i].state == 1) angle = 225;
                    else if (a[i].state == 2) angle = 315;
                    else if (a[i].state == 3) angle = 45;
                    else if (a[i].state == 4) continue;
                } else if (angle == 180) {
                    if (a[i].state == 1) continue;
                    else if (a[i].state == 2) angle = 180;
                    else if (a[i].state == 3) angle = 0;
                    else if (a[i].state == 4) angle = 90;
                } else if (angle == 225) {
                    if (a[i].state == 1) angle = 135;
                    else if (a[i].state == 2) continue;
                    else if (a[i].state == 3) angle = 315;
                    else if (a[i].state == 4) angle = 45;
                } else if (angle == 270) {
                    if (a[i].state == 1) angle = 90;
                    else if (a[i].state == 2) angle = 180;
                    else if (a[i].state == 3) continue;
                    else if (a[i].state == 4) angle = 0;
                } else if (angle == 315) {
                    if (a[i].state == 1) angle = 45;
                    else if (a[i].state == 2) angle = 135;
                    else if (a[i].state == 3) angle = 315;
                    else if (a[i].state == 4) continue;
                }
                curPower = curPower * (100 - a[i].power) / 100;
                if (curPower / power < 0.1) {
                    cout << a[i].x1 << ' ' << a[i].y1 << ' ' << a[i].x2 << ' ' << a[i].y2 << ' ' << (int) (curPower);
                    exit(0);
                }
                break;
            }
        }
        if (angle == 0) {
            x += step;
        } else if (angle == 45) {
            x += step;
            y += step;
        } else if (angle == 90) {
            y += step;
        } else if (angle == 135) {
            x -= step;
            y += step;
        } else if (angle == 180) {
            x -= step;
        } else if (angle == 225) {
            x -= step;
            y -= step;
        } else if (angle == 270) {
            y -= step;
        } else if (angle == 315) {
            x += step;
            y -= step;
        }
    }
    

    return 0;
}
