#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
#include  <chrono>
using namespace std;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

#define int long long

const int MAXSTEPS = 1e5;

bool isAng(int i, int j, int n, int m){
	return (i == 0 && j == 0) || (i == 0 && j == m - 1) || (i == n - 1 && j == 0) || (i == n - 1 && j == m - 1);
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector<vector<int>> a(n, vector<int> (m));
	for (int i = 0; i < n; ++i){
		for (int j = 0; j < m; ++j){
			cin >> a[i][j];
		}
	}
	int stx, sty;
	cin >> stx >> sty;
	int napr;
	cin >> napr;
	int ans = 0;
	stx--;
	sty--;
	int veci = 0, vecj = 0;
	switch (napr)
	{
	case 1:
		veci = -1;
		vecj = -1;
		break;
	case 2:
		veci = -1;
		vecj = 0;
		break;
	case 3:
		veci = -1;
		vecj = 1;
		break;
	case 4:
		veci = 0;
		vecj = -1;
		break;
	case 5:
		veci = 0;
		vecj = 1;
		break;
	case 6:
		veci = 1;
		vecj = -1;
		break;
	case 7:
		veci = 1;
		vecj = 0;
		break;
	case 8:
		veci = 1;
		vecj = 1;
		break;
	}
	ans += a[stx][sty];
	a[stx][sty] = 0;
	int curi = stx, curj = sty;
	if (curi + veci < 0 || curi + veci > n - 1 || curj + vecj < 0 || curj + vecj > m - 1) {
		if (isAng(curi, curj, n, m)) {
			veci = -veci;
			vecj = -vecj;
		} else if (curj == 0 || curj == m - 1){
			vecj = -vecj;
		} else if (curi == 0 || curi == n - 1) {
			veci = -veci;
		}
	}
	curi += veci;
	curj += vecj;
	for (int step = 0; step <= MAXSTEPS; ++step) {
		ans += a[curi][curj];
		a[curi][curj] = 0;
		if (isAng(curi, curj, n, m)) {
			veci = -veci;
			vecj = -vecj;
		} else if (curj == 0 || curj == m - 1){
			vecj = -vecj;
		} else if (curi == 0 || curi == n - 1) {
			veci = -veci;
		}
		curi += veci;
		curj += vecj;
	}
	cout << ans;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int t = 1;
	// cin >> t;
	while (t--){
		solve();
	}
	return 0;
}
