
#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
#include  <chrono>
using namespace std;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

#define int long long

const int MAXSTEPS = 1e5;

struct Plast {
	int x1, y1, x2, y2;
	int absorb;

	Plast() {};
};

double getDistPoints(int x1, int y1, int x2, int y2) { 
	return sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
}

bool pointInPlast(int x, int y, Plast &a) {
	return abs(getDistPoints(x, y, a.x1, a.y1) + getDistPoints(x, y, a.x2, a.y2) - getDistPoints(a.x1, a.y1, a.x2, a.y2)) <= 1e-5;
}

void solve() {
	int napr;
	double power;
	cin >> napr >> power;
	double stpower = power;
	vector<vector<int>> a(401, vector<int> (401, 0));
	int stx = 200, sty = 200;
	int n;
	cin >> n;
	vector<Plast> pl(n);
	for (int i = 0; i < n; ++i){
		cin >> pl[i].x1 >> pl[i].y1 >> pl[i].x2 >> pl[i].y2 >> pl[i].absorb;
	}
	int ptx, pty;
	cin >> ptx >> pty;
	int veci = 0, vecj = 0;
	switch (napr)
	{
	case 45:
		veci = -1;
		vecj = 1;
		break;
	case 90:
		veci = -1;
		vecj = 0;
		break;
	case 135:
		veci = -1;
		vecj = -1;
		break;
	case 180:
		veci = 0;
		vecj = -1;
		break;
	case 225:
		veci = 1;
		vecj = -1;
		break;
	case 270:
		veci = 1;
		vecj = 0;
		break;
	case 315:
		veci = 1;
		vecj = 1;
		break;
	case 0:
		veci = 0;
		vecj = 1;
		break;
	}
	int curi = stx, curj = sty;
	for (int step = 0; step <= MAXSTEPS; ++step) {
		if (curi - 200 == ptx && curj - 200 == pty) {
			cout << int64_t(power);
			return;
		}
		curi += veci;
		curj += vecj;
		for (int i = 0; i < n; ++i) {
			if (pointInPlast(curi - 200, curj - 200, pl[i])) {
				power *= (1 - ((double)pl[i].absorb / 100.0));
				if (power < 0.1 * stpower) {
					cout << pl[i].x1 << ' ' << pl[i].y1 << ' ' << pl[i].x2 << ' ' << pl[i].y2 << ' ' << power;
					return;
				}
				if (pl[i].x1 == pl[i].x2) {
					vecj = -vecj;
				} else if (pl[i].y1 == pl[i].y2) {
					veci = -veci;
				} else {
					if (abs(veci) + abs(vecj) == 1){
						if (veci > 0){
							if ((pl[i].y1 < pl[i].y2 && pl[i].x1 < pl[i].x2) || (pl[i].y2 < pl[i].y1 && pl[i].x2 < pl[i].x1)) {
								veci = 0;
								vecj = -1;
							} else {
								veci = 0;
								vecj = 1;
							}
						} else if (veci < 0) {
							if ((pl[i].y1 < pl[i].y2 && pl[i].x1 < pl[i].x2) || (pl[i].y2 < pl[i].y1 && pl[i].x2 < pl[i].x1)) {
								veci = 0;
								vecj = 1;
							} else {
								veci = 0;
								vecj = -1;
							}
						} else if (vecj > 0) {
							if ((pl[i].y1 < pl[i].y2 && pl[i].x1 < pl[i].x2) || (pl[i].y2 < pl[i].y1 && pl[i].x2 < pl[i].x1)) {
								vecj = 0;
								veci = -1;
							} else {
								vecj = 0;
								veci = 1;
							}
						} else if (vecj < 0) {
							if ((pl[i].y1 < pl[i].y2 && pl[i].x1 < pl[i].x2) || (pl[i].y2 < pl[i].y1 && pl[i].x2 < pl[i].x1)) {
								vecj = 0;
								veci = 1;
							} else {
								vecj = 0;
								veci = -1;
							}
						}
					}
				}
				break;
			}
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int t = 1;
	// cin >> t;
	while (t--){
		solve();
	}

	return 0;
}
