#include <iostream>
#include <string>
#include <stdint.h>

#define C_MAX 1000

int64_t matrix[C_MAX][C_MAX];
bool visited[C_MAX][C_MAX];

uint8_t dirmap[9] = {
    0, 1, 2, 3, 8, 4, 7, 6, 5
};

uint8_t reflHor[9] = {
    0, 7, 6, 5, 4, 3, 2, 1, 8
};

uint8_t reflVer[9] = {
    0, 3, 2, 1, 8, 7, 6, 5, 4
};

int64_t dx[9] = {
    0, -1, 0, 1, 1, 1, 0, -1, -1
};

int64_t dy[9] = {
    0, -1, -1, -1, 0, 1, 1, 1, 0
};

/*
123
8x4
765

1 2 3 4 5
6 7 8 9 0
4 5 3 2 1
*/

int main() {
    uint32_t n, m;
    std::cin >> n >> m;

    for(uint32_t i = 0; i < n; i++) {
        for(uint32_t j = 0; j < m; j++) {
            visited[i][j] = false;
            std::cin >> matrix[i][j];
        }
    }

    int64_t x, y, d;
    std::cin >> y >> x >> d;

    int64_t score = 0;

    x--;
    y--;

    d = dirmap[d];

    while(!visited[y][x]) {
        score += matrix[y][x];

        visited[y][x] = true;

        bool reflected = false;

        if(y + dy[d] >= n || y + dy[d] < 0) {
            d = reflHor[d];
            reflected = true;
        }

        if(x + dx[d] >= m || x + dx[d] < 0) {
            d = reflVer[d];
            reflected = true;
        }

        if(reflected)
            d = 1 + d % 8;

        x += dx[d];
        y += dy[d];
    }

    std::cout << score << "\n";

    return 0;
}
