#include <iostream>
#include <string>
#include <stdint.h>

#define N_MAX 10

bool blocks[N_MAX][3][3];
bool field[3][N_MAX * 3];
bool oldfield[1000][3][N_MAX * 3];
uint32_t path[N_MAX];
bool visited[N_MAX + 1];
uint32_t current = 0;

uint32_t n;

void backupField() {
    for(uint32_t i = 0; i < 3; i++) {
        for(uint32_t j = 0; j < n * 3; j++) {
            oldfield[current][i][j] = field[i][j];
        }
    }
}

void restoreField() {
    for(uint32_t i = 0; i < 3; i++) {
        for(uint32_t j = 0; j < n * 3; j++) {
            field[i][j] = oldfield[current][i][j];
        }
    }
}

bool canBlockBePlaced(uint32_t y, bool block[3][3]) {
    for(uint32_t i = 0; i < 3; i++) {
        for(uint32_t j = 0; j < 3; j++) {
            if(field[i][j + y] && block[i][j]) {
                restoreField();
                return false;
            }

            field[i][j + y] = block[i][j];
        }
    }

    for(uint32_t i = 0; i < 3; i++) {
        for(uint32_t j = 0; j < 2; j++) {
            if(!field[i][j + y] && field[i][j + y + 1]) {
                restoreField();
                return false;
            }
        }
    }

    return true;
}

bool check(uint32_t v, uint32_t rotation) {
    bool block[3][3];

    if(rotation) {
        for(uint32_t i = 0; i < 3; i++) {
            for(uint32_t j = 0; j < 3; j++) {
                block[i][j] = blocks[v][2 - i][2 - j];
            }
        }
    } else {
        for(uint32_t i = 0; i < 3; i++) {
            for(uint32_t j = 0; j < 3; j++) {
                block[i][j] = blocks[v][i][j];
            }
        }
    }

    for(uint32_t y = 0; y < n * 3 - 2; y++) {
        if(canBlockBePlaced(y, block)) {
            return true;
        }
    }

    return false;
}

bool dfs(uint32_t v) {
    path[current] = v;
    visited[v] = true;
    current++;

    for(uint32_t u = 0; u < n; u++) {
        if(visited[u]) continue;

        for(uint32_t r = 0; r < 2; r++) {
            backupField();
            if(check(u, r) && dfs(u)) {
                restoreField();
                return true;
            }
            restoreField();
        }
    }

    visited[v] = false;
    current--;

    return false;
}

int main() {
    std::cin >> n;

    for(uint32_t t = 0; t < n; t++) {
        for(uint32_t i = 0; i < 3; i++) {
            for(uint32_t j = 0; j < 3; j++) {
                std::cin >> blocks[t][i][j];
            }
        }
    }

    if(dfs(N_MAX + 1)) {
        for(uint32_t i = 0; i < current; i++) {
            std::cout << path[i] << " ";
        }

        std::cout << "\n";
    }

    return 0;
}
